<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 0;
var currentStep = 1;

var runParametersIsValid = [];

function init()
{
	var frm = document.forms['reggie'];
	var seqRuns = getSequencingRuns();

	// Load existing SequencingRun items with no end date
	if (seqRuns != null && seqRuns.length > 0)
	{
		for (var runNo=0; runNo < seqRuns.length; runNo++)
		{
			var seqRun = seqRuns[runNo];
			var flowCell = seqRun.flowCell;
			var name = seqRun.name+': ';

			var numPools = flowCell.pools.length;
			var firstPoolNum = getPoolNum(flowCell.pools[0].name);
			var lastPoolNum = getPoolNum(flowCell.pools[flowCell.pools.length-1].name);

			if (lastPoolNum - firstPoolNum == numPools - 1)
			{
				if (numPools > 1)
				{
					// Display: PoolN -- PoolY
					name += flowCell.pools[0].name + ' — ' + flowCell.pools[flowCell.pools.length-1].name;
				}
				else
				{
					name += flowCell.pools[0].name;
				}
			}
			else
			{
				// Display: PoolN + x more...
				name += flowCell.pools[0].name + ' + ' + (numPools-1) + ' more...';
			}

			// Tooltip is always all pools
			var title = '';
			for (var poolNo=0; poolNo < numPools; poolNo++)
			{
				var pool = flowCell.pools[poolNo];
				if (poolNo > 0) title += ', ';
				title += pool.name;
			}

			var option = new Option(name, seqRun.id);
			option.title = title;
			option.seqRun = seqRun;
			frm.seqRuns.options[frm.seqRuns.length] = option;
		}
		sequencingRunOnChange();
	}
	else
	{
		var msg = 'No sequencing runs available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.seqRuns.focus();
}

function getPoolNum(poolName)
{
	var num = poolName.match(/Pool(\d+)/);
	return num ? parseInt(num[1], 10) : null;	
}


function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	setCurrentStep(currentStep);
}

function step1IsValid()
{
	return true;
}

function step2IsValid()
{
	var frm = document.forms['reggie'];
	if (!document.getElementById('outcomeSuccess').checked && !frm.verifyFailure.checked) return false;

	return true;
}


function getSequencingRuns()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading sequencing runs...');
		var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=GetUnconfirmedSequencingRuns';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.sequencingRuns;
}

function sequencingRunOnChange()
{
	var frm = document.forms['reggie'];	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	
	setInnerHTML('startDate', formatDate(seqRun.SequencingStart));
	setInnerHTML('endDate', formatDate(seqRun.SequencingEnd));
	
	Forms.checkRadio(frm.outcome, seqRun.SequencingResult || 'Successful');
	outcomeOnChange();
		
	var fc = seqRun.flowCell;
	setInnerHTML('flowCellInRun', '<b>['+seqRun.HiSeqPosition+']</b> ' + fc.FlowCellID);
	
	var pools = fc.pools;
	var html = '';
	var libPlateHtml = '';
	for (var poolNo = 0; poolNo < pools.length; poolNo++)
	{
		var pool = pools[poolNo];
		if (poolNo > 0) html += ', ';
		html += Main.encodeTags(pool.name);
		if (pool.LibPlate && libPlateHtml.indexOf(pool.LibPlate.name) == -1)
		{
			if (libPlateHtml.length > 0) libPlateHtml += ', ';
			libPlateHtml += Main.encodeTags(pool.LibPlate.name);
		}
	}
	setInnerHTML('pools', html);
	setInnerHTML('libPlate', libPlateHtml || 'n/a');
	setInnerHTML('comments', Main.encodeTags(seqRun.comments));
}

function outcomeOnChange()
{
	var frm = document.forms['reggie'];	

	frm.flagPools.disabled = !document.getElementById('outcomeFailed').checked;
}

function formatDate(value)
{
	if (!value) return '';
	if (value.length == 8)
	{
		// YYYYMMDD
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	else if (value.length == 13)
	{
		// YYYYMMDD HHMM
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2) + ' ' + value.substr(9, 2) + ':' + value.substr(11, 2);
	}
	return value;
}


function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	// Disable controls
	frm.seqRuns.disabled = true;

	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.show('gocancel');
	Main.show('goregister');
	Main.hide('gonext');
	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	var outcome = Forms.getCheckedRadio(frm, 'outcome').value;
	
	frm.sequencingComments.value = seqRun.comments;
	setInnerHTML('step.2.title', seqRun.name);

	var fc = seqRun.flowCell;
	if (outcome != 'Successful')
	{
		setInnerHTML('gonext.message', '<input type="checkbox" name="verifyFailure" onclick="verifyFailureOnClick()"> Check to verify registration of failure');
		Main.addClass(document.getElementById('goregister'), 'disabled');
		Main.hide('failedLanesRow');
	}
	else
	{
		// Failed lanes
		var html = '';
		for (var laneNo = 1; laneNo <= fc.numLanes; laneNo++)
		{
			html += '<label><input type="checkbox" name="failedLanes" value="'+laneNo+'">'+laneNo+'</label> ';
		}
		setInnerHTML('failedLanes', html);
		Main.show('failedLanesRow');
	}
}

function verifyFailureOnClick()
{
	var frm = document.forms['reggie'];
	var checked = frm.verifyFailure.checked;
	Main.addOrRemoveClass(document.getElementById('goregister'), 'disabled', !checked);
}


function goRegister()
{
	if (!step2IsValid()) return;
	
	var frm = document.forms['reggie'];
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	frm.sequencingComments.disabled = true;
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	var outcome = Forms.getCheckedRadio(frm, 'outcome').value;
	var submitInfo = {};
	
	submitInfo.flagPools = !frm.flagPools.disabled && frm.flagPools.checked ? true : false;

	seqRun.comments = frm.sequencingComments.value;
	seqRun.SequencingResult = outcome;
	submitInfo.sequencingRun = seqRun;
		
	if (outcome == 'Successful')
	{
		var fc = seqRun.flowCell;
		var failedLanes = [];
		var checkboxes = frm['failedLanes'];
		for (var i = 0; i < checkboxes.length; i++)
		{
			if (checkboxes[i].checked) failedLanes[failedLanes.length] = parseInt(checkboxes[i].value);
		}
		fc.failedLanes = failedLanes;
	}
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=ConfirmSequencingEnded';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}



</script>
<style>
.fc-info
{
	background-color: #F4F4F4;
	border-top: 1em solid transparent;
	border-bottom: 1em solid transparent;
}

.fc-info .subprompt
{
	font-weight: normal;
	padding-left: 2em;
	text-align: left;
}

.fc-info .input
{
	font-style: italic;
}


</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Confirm sequencing completed" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select sequencing run</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Sequencing run</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="seqRuns" id="seqRuns" onchange="sequencingRunOnChange()"></select>
				</td>
				<td class="status" id="seqRuns.status"></td>
				<td class="help"><span id="seqRuns.message" class="message" style="display: none;"></span>
					Select the sequencing run that has ended.
				</td>
			</tr>
			<tbody class="fc-info">
			<tr valign="top">
				<td class="subprompt">Start date</td>
				<td class="input" id="startDate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">End date</td>
				<td class="input" id="endDate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Flow cell</td>
				<td class="input" id="flowCellInRun"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Pools</td>
				<td class="input" id="pools"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">LibPlate</td>
				<td class="input" id="libPlate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Comments</td>
				<td class="input" id="comments"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			<tr valign="top">
				<td class="prompt">Outcome</td>
				<td class="input" colspan="2">
					<label><input type="radio" name="outcome" id="outcomeSuccess" value="Successful"
						onclick="outcomeOnChange()"
						checked>Success</label> - continue with demux<br>
					<label><input type="radio" name="outcome" id="outcomeFirstBaseReportFailed" value="FirstBaseReportFailed"
						onclick="outcomeOnChange()"
						>FirstBaseReportFailed</label> - re-start sequencing<br>
					<label><input type="radio" name="outcome" id="outcomeFailed" value="Failed"
						onclick="outcomeOnChange()"
						>Failure</label><br>
					<img src="../images/joinbottom.gif"><label><input type="checkbox" name="flagPools" value="1" disabled checked>Flag pools for re-clustering</label>
					
				</td>
				<td class="help">
					Select <b>FirstBaseReportFailed</b> if sequencing can be re-started with the
					same flow cell. This is registered as a new sequencing run and no further analysis
					is made from this run.<br>
					Select the <b>Failure</b> option if further analysis of the data is not possible.
					No child bioassay set will be created. Existing pooled libraries can optionally
					be flagged for re-clustering on a new flow cell.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle" id="step.2.title">SequencingRun</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top" id="failedLanesRow">
				<td class="prompt">Failed lanes</td>
				<td class="input" id="failedLanes"></td>
				<td class="status" id="failedLanes.status"></td>
				<td class="help"><span id="failedLanes.message" class="message" style="display: none;"></span>
					Mark the checkboxes for lanes that have failed and should not be included in the demux.
				</td>
			</tr>
			
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea rows="6" cols="50" style="width: 95%;" name="sequencingComments" value=""></textarea></td>
				<td class="status" id="sequencingComments.status"></td>
				<td class="help"><span id="sequencingComments.message" class="message" style="display: none;"></span>Comments about the sequencing.</td>
			</tr>
			
			</table>
		</td>
	</tr>
	</table>
	</div>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>