<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 0;

function init()
{
	var frm = document.forms['reggie'];
	var flowCells = getFlowCells();
	
	// Load existing Flow cells not yet registered
	var fcells = frm.flowcells;
	if (flowCells != null && flowCells.length > 0)
	{
		for (var i=0; i < flowCells.length; i++)
		{
			var flowCell = flowCells[i];
			var name = flowCell.name +': ';

			var numPools = flowCell.pools.length;
			var firstPoolNum = getPoolNum(flowCell.pools[0].name);
			var lastPoolNum = getPoolNum(flowCell.pools[flowCell.pools.length-1].name);

			if (lastPoolNum - firstPoolNum == numPools - 1)
			{
				// Display: PoolN -- PoolY
				name += flowCell.pools[0].name + ' — ' + flowCell.pools[flowCell.pools.length-1].name;
			}
			else
			{
				// Display: PoolN + x more...
				name += flowCell.pools[0].name + ' + ' + (numPools-1) + ' more...';
			}

			// Tooltip is always all pools
			var title = '';
			for (var poolNo=0; poolNo < numPools; poolNo++)
			{
				var pool = flowCell.pools[poolNo];
				if (poolNo > 0) title += ', ';
				title += pool.name;
			}

			var option = new Option(name, flowCell.id, i < 2);
			option.title = title;
			option.flowCell = flowCell;
			fcells.options[fcells.length] = option;
		}
		flowCellIsValid = true;
		Main.show('gocreate');
	}
	else
	{
		var msg = 'No flow cells available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.flowcells.focus();
}

function getPoolNum(poolName)
{
	var num = poolName.match(/Pool(\d+)/);
	return num ? parseInt(num[1], 10) : null;	
}

function getFlowCells()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading flow cells lists...');
		var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetUnprocessedFlowCells';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.flowCells;
}

/**
 * Returns comma-separated list of selected option values.
 *
 * @param elementId The HTML element id for the select component in the web page.
 * @return A comma-selected list of selected option values.
 */
function getSelectBoxResults(elementId)
{
	var selectBox = document.getElementById(elementId);
	var numSelected = 0;
	var selectedList = '';
	for (var count = 0; count < selectBox.options.length; count++)
	{
		if (selectBox.options[count].selected == true)
		{
			var option = selectBox.options[count];
			var id = option.value;
			numSelected++;
			if (numSelected > 1)
			{
				selectedList += ',';
			}
			selectedList += id;
		}
	}
	return selectedList;
}

/**
 * Returns comma-separated list of number of lanes in flow cells.
 *
 * @param idList A comma-separated list of flow cell database id values.
 * @return A comma-selected list of number of lanes in flow cells.
 */
function getFlowCellNumLanesList(idList)
{
	var flowCellInfoArray = getFlowCellInfo(idList);
	var numLanesList = '';
	var flowCellNo = -1;
	for (var index in flowCellInfoArray)
	{
		flowCellNo++;
		var flowCell = flowCellInfoArray[index];
		var numLanes = flowCell['numLanes'];
		if (flowCellNo > 0)
		{
			numLanesList += ',';
		}
		numLanesList += numLanes;
	}
	return numLanesList;
}

/**
 * Returns a JSONArray with data for flow cells with database id values
 * in input comma-separated string list.
 *
 * @param idList A comma-separated list of flow cell database id values.
 * @return JSONArray with data for flow cells with input database id values.
 */
function getFlowCellInfo(idList)
{
	var frm = document.forms['reggie'];	

	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading flow cell info...');
		var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetFlowCellInfo';
		url += '&idlist='+idList;
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.flowCellInfo;
}

function goCreate()
{
	var frm = document.forms['reggie'];
	frm.flowcells.disabled = true;
	
	Main.hide('gocreate');

	// Get comma-separated list of id values of selected flow cells
	var selectedList = getSelectBoxResults("flowcells");
	// Get comma-separated list of number of lanes of selected flow cells
	var numLanesList = getFlowCellNumLanesList(selectedList);
	frm.flowcellidlist.value = selectedList;
	frm.numlaneslist.value = numLanesList;
	frm.submit();

	Main.show('gorestart');	
}
</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab protocol for clustering and sequencing" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with creating the protocol but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="flowcell_protocol2.jsp" method="post" target="_blank">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="flowcellidlist" value="">
		<input type="hidden" name="numlaneslist" value="">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select flow cells</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Flow cells</td>
				<td class="input"><select class="required" style="width:100%;" 
						name="flowcells" id="flowcells" multiple size="4"></select>
				</td>
				<td class="status" id="flowcells.status"></td>
				<td class="help"><span id="flowcells.message" class="message" style="display: none;"></span>
					Select one or more existing flow cells. The list contains all flow cells that
					has not yet been clustered or sequenced (determined by the absence of a 'creation' date).
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocreate" title="Create protocol" image="<%=home+"/images/import.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>